//=====================================================================================================================
// Copyright (c) 2016-2017. Aurea Software, Inc. All Rights Reserved.
//
// You are hereby placed on notice that the software, its related technology and services may be covered by one or
// more United States ("US") and non-US patents. A listing that associates patented and patent-pending products
// included in the software, software updates, their related technology and services with one or more patent numbers
// is available for you and the general public's access at www.aurea.com/legal/ (the "Patent Notice") without charge.
// The association of products-to-patent numbers at the Patent Notice may not be an exclusive listing of associations,
// and other unlisted patents or pending patents may also be associated with the products. Likewise, the patents or
// pending patents may also be associated with unlisted products. You agree to regularly review the products-to-patent
// number(s) association at the Patent Notice to check for updates.
//=====================================================================================================================

package com.actional.soapapi.anttask.soapstation;

import com.actional.soapapi.Util;
import org.apache.tools.ant.types.Reference;

/** <!-- ========================================================================================================== -->
* Publish the specified {@link com.actional.soapstation.db.AccessPointNode} in the specified UDDI repository.
* <!-- --------------------------------------------------------------------------------------------------------- --> */

public class UnpublishAccessPointTask extends SOAPstationTaskBase
{
	//=============================================================================================================
	// The ant task Properties
	//=============================================================================================================

	protected Reference itsAccessPoint;

	public void setAccessPointRef(Reference val)	{ itsAccessPoint = val; }

	protected String resolveRefIDWithThrow(Reference val, String name) throws Exception
	{
		String keyID = locateBaseDataID(val);

		if (Util.isBlank(keyID))
			throw new Exception("Missing '" + name + "' value.");

		return keyID;
	}

	/** <!-- ================================================================================================== -->
	* Do the work
	* <!-- ------------------------------------------------------------------------------------------------- --> */

	@Override
	public void executeEx() throws Exception
	{
		String apKeyID = resolveRefIDWithThrow(itsAccessPoint, "AccessPointRef");

		log("Unpublishing Access Point: " + apKeyID);
		_getSSTConfig().uddiTask.unpublishAccessPoint(apKeyID, false);
	}
}

