@echo off
@REM =====================================================================================================================
@REM  _DISTRIB_BEGIN_REMOVE_
@REM  $HeadURL$
@REM  Checked in by: $Author$
@REM  $Date$
@REM  $Revision$
@REM ---------------------------------------------------------------------------------------------------------------------
@REM  _DISTRIB_END_REMOVE_
@REM  Copyright (c) 2016-2017. Aurea Software, Inc. All Rights Reserved.
@REM 
@REM  You are hereby placed on notice that the software, its related technology and services may be covered by one or
@REM  more United States ("US") and non-US patents. A listing that associates patented and patent-pending products
@REM  included in the software, software updates, their related technology and services with one or more patent numbers
@REM  is available for you and the general public's access at www.aurea.com/legal/ (the "Patent Notice") without charge.
@REM  The association of products-to-patent numbers at the Patent Notice may not be an exclusive listing of associations,
@REM  and other unlisted patents or pending patents may also be associated with the products. Likewise, the patents or
@REM  pending patents may also be associated with unlisted products. You agree to regularly review the products-to-patent
@REM  number(s) association at the Patent Notice to check for updates.
@REM =====================================================================================================================

setlocal

if "%JAVA_HOME%" == "" set JAVA_HOME=%~dp0..\jre

set CLASS_DIR=.\classes
set CLASS_BUILD_DIR=.\build\anttask\classes

set CLASSPATH=.

rem Pick up the freshly compiled jars first.
call :AddToClassPath actional-javaClient.jar
call :AddToClassPath actional-soapapi-sdk.jar
call :AddToClassPath actional-taskapi.jar

set CLASSPATH=%CLASSPATH%;%CLASS_DIR%\axis.jar
set CLASSPATH=%CLASSPATH%;%CLASS_DIR%\jaxrpc.jar
set CLASSPATH=%CLASSPATH%;%CLASS_DIR%\commons-logging.jar
set CLASSPATH=%CLASSPATH%;%CLASS_DIR%\commons-discovery.jar
set CLASSPATH=%CLASSPATH%;%CLASS_DIR%\javax.servlet.jar
set CLASSPATH=%CLASSPATH%;%CLASS_DIR%\saaj.jar


rem The following lines are used if we would like to use https to talk to Actional Server:
rem
rem The following is used to import the SOAPstation certificate into the java keystore.
rem %JAVA_HOME%\jre\bin\keytool.exe -import -alias SST -file soapstation.cer -keystore truststore -trustcacerts
rem
rem This line is needed to tell java which keystore to use.
rem set SEC=-Djavax.net.ssl.trustStore=truststore -Djavax.net.ssl.keyStore=truststore -Djavax.net.ssl.keyStorePassword=changeit
rem

set DEBUG_OPTS=-Xdebug -Xrunjdwp:transport=dt_shmem,address=javaClient,server=y,suspend=n


rem Do the import
%JAVA_HOME%\bin\java %SEC% %DEBUG_OPTS% -Daxis.ClientConfigFile=client-config.wsdd com.actional.soapapi.javaClient.ServerClient %*
goto :EOF


:AddToClassPath
rem Pick up the freshly compiled jars first.
if exist %CLASS_BUILD_DIR%\%1 (
	set CLASSPATH=%CLASSPATH%;%CLASS_BUILD_DIR%\%1
) ELSE (
	set CLASSPATH=%CLASSPATH%;%CLASS_DIR%\%1
)
goto :EOF
